<template>
  <v-card class="pt-4">
    <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-smartphone' : 'dialog-content-scrollerd'">
      <v-form ref="form" @submit.prevent="validarFormulario">
        <v-text-field
          v-model="formMascota.nombre"
          label="Nombre de la mascota"
          type="text"
          :rules="rules.required"
          required
          autofocus
          color="accent"
        />
        <v-text-field
          v-model="formMascota.raza"
          label="Raza"
          type="text"
          :rules="rules.required"
          required
          color="accent"
        />
        <v-select
          v-model="formMascota.sexo"
          :rules="rules.required"
          :items="sexo"
          item-text="label"
          item-value="label"
          color="accent"
          label="Sexo"
          placeholder="Seleccione"
        />
        <v-menu
          ref="menufecha"
          v-model="menufecha"
          :close-on-content-click="false"
        >
          <template #activator="{ on }">
            <v-text-field
              v-model="fechaNacimiento"
              label="Fecha de Nacimiento"
              placeholder="Haga Click Aquí"
              prepend-icon="fal fa-calendar-minus"
              readonly
              color="accent"
              v-on="on"
            />
          </template>
          <v-date-picker
            ref="picker"
            v-model="formMascota.fecha_nacimiento"
            locale="es-es"
            :max="new Date().toISOString().substr(0, 10)"
            min="1930-01-01"
            color="accent"
            @change="menufecha=false"
          />
        </v-menu>
        <v-textarea
          v-model="formMascota.observaciones"
          outlined
          :rules="rules.required"
          color="accent"
          label="Observaciones"
        />
      </v-form>
    </v-card-text>

    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
        Cerrar
      </v-btn>
      <v-spacer />
      <v-btn v-if="!isEditar" class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Agregar
      </v-btn>
      <v-btn v-else class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Modificar
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue, Watch } from 'vue-property-decorator'
import { Mascota } from '~/core/models/mascota'
import { EnumsHelpers } from '~/core/helpers/EnumsHelpers'
import { getSexo, SexoEnum } from '~/core/enums/SexoEnum'
import AppToast from '~/core/utils/AppToast'
import { AppStore } from '~/store/AppStore'
import { MascotasStore } from '~/store/MascotasStore'
import { DateHelpers } from '~/core/helpers/DateHelpers'
import { Cliente } from '~/core/models/cliente'

@Component
export default class formMascotas extends Vue {
  @Ref('form') formulario;
  @Ref('picker') picker;

  @Prop({ default: null }) mascota!:Mascota;
  @Prop({ default: null }) clienteActual!:Cliente;

  menufecha:boolean = false;

  formMascota:Mascota = {
    nombre: '',
    raza: '',
    fecha_nacimiento: '',
    observaciones: '',
    sexo: ''
  };

  get sexo () {
    return EnumsHelpers.enumtolist(SexoEnum).map(p => getSexo(p.id))
  }

  get fechaNacimiento ():string {
    return this.formMascota.fecha_nacimiento ? DateHelpers.convertHumanFecha(this.formMascota.fecha_nacimiento) : ''
  }

  @Watch('menufecha')
  onmenufechachange () {
    setTimeout(() => (this.picker.activePicker = 'YEAR'))
  }

  rules = {
    required: [
      v => !!v || 'Campo requerido'
    ]
  };

  get isEditar () {
    return this.mascota
  }

  mounted () {
    if (this.isEditar) {
      this.cargarForm()
    }
  }

  private cargarForm () {
    Object.assign(
      this.formMascota,
      this.mascota
    )
  }

  cerrarDialog () {
    this.$emit('onClose')
  }

  validarFormulario () {
    if (this.clienteActual) {
      if (this.formulario.validate()) {
        if (this.isEditar) {
          this.modificar()
        } else {
          this.guardar()
        }
      } else {
        AppToast.error('Campos inválidos')
      }
    } else {
      AppToast.error('Por favor seleccione un cliente para continuar')
    }
  }

  private async guardar () {
    AppStore.SHOW_LOADING('Guardando mascota')
    this.formMascota.clientes_idclientes = this.clienteActual.idclientes
    try {
      await MascotasStore.registrarMascota(this.formMascota)
      this.cerrarDialog()
      AppToast.success('Mascota registrada')
    } catch (e) {
    }
    AppStore.HIDE_LOADING()
  }

  private async modificar () {
    AppStore.SHOW_LOADING('Guardando mascota')
    try {
      await MascotasStore.modificarMascota(this.formMascota)
      this.cerrarDialog()
      AppToast.success('Mascota registrada')
    } catch (e) {
    }
    AppStore.HIDE_LOADING()
  }
}
</script>

<style lang="scss">

</style>
